/*
  stores an array and builds to each inserted array the average and stores it
  Copyright (C) 1998  Martin Vogt;Philip VanBaren, 2 September 1993

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */






#ifndef __ARRAYAVERAGE_H
#define __ARRAYAVERAGE_H



/**

  This function stores an array of int's with a given size.
  First this array contains zeros. (after a reset) 
  Then you can add another array. The both array are added (
  no overflow detection!) And then the values are diveded by 2.
  Each time a counter is incremented.
  <p>
  The "adjust" method adjust the stored array in the direction
  of the given Array. The adjustment ist saved in the Array.
  E.G
  <p>
  stored 1   2  3  4 5 6<p>
  param  10  11 12 1 2 3<p>
  <p>
  next   2   2  3  3 4 5    ( if the maxStep is high)
  <p>
  maxStep: take care that after maxStep the values are the same.
  (calulates the speed in which each array column is adjusted)

*/



class ArrayAverage {

  int* array;
  int arraySize;

  int counter;

 public:
  ArrayAverage(int arraySize);
  ~ArrayAverage();

  void insert(int* aArray);
  void adjust(int* aArray,int maxSteps);

  int* getArray();

  int getSize();
  void reset();

  int getCounter();
  void setCounter(int value);
};

#endif
